glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::MenuAttributeIter Class Reference

MenuAttributeIter - A menu attribute iterator. More...

`#include <giomm/menuattributeiter.h>`

Inheritance diagram for Gio::MenuAttributeIter:
[legend]

## Public Member Functions
| MenuAttributeIter (MenuAttributeIter&& src) noexcept
MenuAttributeIter& | operator= (MenuAttributeIter&& src) noexcept
| ~MenuAttributeIter () noexcept override
GMenuAttributeIter* | gobj ()
| Provides access to the underlying C GObject. More...
const GMenuAttributeIter* | gobj () const
| Provides access to the underlying C GObject. More...
GMenuAttributeIter* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | get_next (Glib::ustring& out_name, Glib::VariantBase& value)
| This function combines g_menu_attribute_iter_next() with g_menu_attribute_iter_get_name() and g_menu_attribute_iter_get_value(). More...
Glib::ustring | get_name () const
| Gets the name of the attribute at the current iterator position, as a string. More...
Glib::VariantBase | get_value ()
| Gets the value of the attribute at the current iterator position. More...
const Glib::VariantBase | get_value () const
| Gets the value of the attribute at the current iterator position. More...
bool | next ()
| Attempts to advance the iterator to the next (possibly first) attribute. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| MenuAttributeIter ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::MenuAttributeIter > | wrap (GMenuAttributeIter* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

MenuAttributeIter - A menu attribute iterator.

Since glibmm 2.32:

## Constructor & Destructor Documentation

## ◆ MenuAttributeIter() [1/2]

Gio::MenuAttributeIter::MenuAttributeIter | ( | MenuAttributeIter&& | src | ) |
| noexcept

## ◆ ~MenuAttributeIter()

Gio::MenuAttributeIter::~MenuAttributeIter | ( |  | ) |
| override noexcept

## ◆ MenuAttributeIter() [2/2]

Gio::MenuAttributeIter::MenuAttributeIter | ( |  | ) |
| protected

## Member Function Documentation

## ◆ get_name()

Glib::ustring Gio::MenuAttributeIter::get_name | ( |  | ) | const

Gets the name of the attribute at the current iterator position, as a string.

The iterator is not advanced.

Since glibmm 2.32:

Returns
  The name of the attribute.

## ◆ get_next()

bool Gio::MenuAttributeIter::get_next | ( | Glib::ustring& | out_name,
|  | Glib::VariantBase& | value
| ) |  |

This function combines g_menu_attribute_iter_next() with g_menu_attribute_iter_get_name() and g_menu_attribute_iter_get_value().

First the iterator is advanced to the next (possibly first) attribute. If that fails, then `false` is returned and there are no other effects.

If successful, name and value are set to the name and value of the attribute that has just been advanced to. At this point, g_menu_attribute_iter_get_name() and g_menu_attribute_iter_get_value() will return the same values again.

The value returned in name remains valid for as long as the iterator remains at the current position. The value returned in value must be unreffed using Glib::variant_unref() when it is no longer in use.

Since glibmm 2.32:

Parameters

  out_name | The type of the attribute.
  value | The attribute value.

Returns
  `true` on success, or `false` if there is no additional attribute.

## ◆ get_type()

static GType Gio::MenuAttributeIter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_value() [1/2]

Glib::VariantBase Gio::MenuAttributeIter::get_value | ( |  | ) |

Gets the value of the attribute at the current iterator position.

The iterator is not advanced.

Since glibmm 2.32:

Returns
  The value of the current attribute.

## ◆ get_value() [2/2]

const Glib::VariantBase Gio::MenuAttributeIter::get_value | ( |  | ) | const

Gets the value of the attribute at the current iterator position.

The iterator is not advanced.

Since glibmm 2.32:

Returns
  The value of the current attribute.

## ◆ gobj() [1/2]

GMenuAttributeIter* Gio::MenuAttributeIter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GMenuAttributeIter* Gio::MenuAttributeIter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GMenuAttributeIter* Gio::MenuAttributeIter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ next()

bool Gio::MenuAttributeIter::next | ( |  | ) |

Attempts to advance the iterator to the next (possibly first) attribute.

`true` is returned on success, or `false` if there are no more attributes.

You must call this function when you first acquire the iterator to advance it to the first attribute (and determine if the first attribute exists at all).

Since glibmm 2.32:

Returns
  `true` on success, or `false` when there are no more attributes.

## ◆ operator=()

MenuAttributeIter& Gio::MenuAttributeIter::operator= | ( | MenuAttributeIter&& | src | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::MenuAttributeIter > wrap | ( | GMenuAttributeIter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.